GNU bug report logs - #51215
Add a navigation feature to vc and diff mode: diff-goto-line

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Uwe Brauer <oub@HIDDEN>; Keywords: patch; dated Thu, 14 Oct 2021 20:44:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 51215 <at> debbugs.gnu.org:


Received: (at 51215) by debbugs.gnu.org; 19 Oct 2021 23:18:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 19 19:18:30 2021
Received: from localhost ([127.0.0.1]:52244 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mcyNK-0007hR-HC
	for submit <at> debbugs.gnu.org; Tue, 19 Oct 2021 19:18:30 -0400
Received: from mail-lf1-f48.google.com ([209.85.167.48]:41844)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1mcyN4-0007gi-UQ
 for 51215 <at> debbugs.gnu.org; Tue, 19 Oct 2021 19:18:29 -0400
Received: by mail-lf1-f48.google.com with SMTP id u21so10954434lff.8
 for <51215 <at> debbugs.gnu.org>; Tue, 19 Oct 2021 16:18:14 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=LpXzTvRqQV8tp6lUZKWCmYzNcpsgw5nT5J2pGeuhMIY=;
 b=NfDxbQWWmPv3CKFt6ohaEdi/+323rNtaIwu+F/e4PnDETVXoGuJhrrls6/0+9dj/DW
 1u4GsOY1f7obPuo6fdfhY11rN5efQoVgz2INr0ibGTxHEibf4SaUwkVpsDSR15Mblbv6
 12RbuEwDo1PXaJUmdcVqgRqVkUz4U1apb/a/tZO1Rhz1/8e38MzW6BDVcbsTYiQRqq1l
 y2VQtc7OpWt6b8c99ryoko+TjKeWdGliQ0CWAvSVsXpWvGkpaWDoH/56M/Jn3FsVPpcH
 /UrDMCY4xruI6cS8rvLz/m+9bd0F7VP3M/ZiWK7+7a7RgL4K7qaY/ZLY1pH2gOw3TkmP
 rhvg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=LpXzTvRqQV8tp6lUZKWCmYzNcpsgw5nT5J2pGeuhMIY=;
 b=bS76Ph8pMglhqX54UK9V7Argi6x4fR05YI6pLFOkV8q6LAdxGn6IgrzvZ7IVPHQ+cM
 TIztZRfpKNppKzY+A7VNJGTLxaB17XO1274rdN192Uz2Q2GEYdkvKiBGE2gU1TTz2oMa
 st7C5sdTu4lo1zY1LdKLyYmw2+1jdPBfhL3jmnIo2sV21KbK+X1UUGkVqkDlWsAmgbCP
 c/zNzHNT2G1iQvcOwygGBKjAhHLuThLzRYpJkgkOTKa0Iz+FZmMD+8nZjL1ZGjvxaoPg
 /nwDTU2RGJuYIK+xaVZBTHiR0vg2WH7wz/eFJjxoWWx/vVfrhVOGuLJ12UMBKjv9u1rw
 FMVw==
X-Gm-Message-State: AOAM530bD2FSwWM2uDuSPb+EnnJH8O/NylfyRt4M/WWtpctfgGXWbAsn
 5DENkDfkDCWFZ6w6T4I4lDA=
X-Google-Smtp-Source: ABdhPJxv1uh64pM+a2xhe4Tj3qMrr3o0uGX4fmSA17fNyoJQIAi9GM0GkGt6J1tPAn+GYIBFzOrsIw==
X-Received: by 2002:a05:6512:31c4:: with SMTP id
 j4mr8967856lfe.368.1634685488824; 
 Tue, 19 Oct 2021 16:18:08 -0700 (PDT)
Received: from [192.168.0.103] ([5.18.248.29])
 by smtp.googlemail.com with ESMTPSA id o21sm39520ljg.93.2021.10.19.16.18.07
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Tue, 19 Oct 2021 16:18:08 -0700 (PDT)
Subject: Re: bug#51215: Add a navigation feature to vc and diff mode:
 diff-goto-line
To: Juri Linkov <juri@HIDDEN>
References: <87k0ifpcc2.fsf@HIDDEN>
 <9618968c-f3f4-da4f-4dba-e34a88036ced@HIDDEN> <87k0iag5vr.fsf@HIDDEN>
 <87ee8ig5ib.fsf@HIDDEN> <d2140f38-05cd-fc40-c009-4430086df235@HIDDEN>
 <87lf2ple0n.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <881adad6-19bf-b021-52b7-ae05d465efbe@HIDDEN>
Date: Wed, 20 Oct 2021 02:18:07 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.13.0
MIME-Version: 1.0
In-Reply-To: <87lf2ple0n.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.4 (/)
X-Debbugs-Envelope-To: 51215
Cc: "Herring, Davis" <herring@HIDDEN>, 51215 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.6 (/)

On 19.10.2021 09:53, Juri Linkov wrote:
>>> https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36526
>>> Is a different patch than the one I committed. Mine (=Davis) does not
>>> touch the vc-root-diff command it is on a strict one-file base and
>>> therefore simpler.
>>> Why not apply «mine» and if there is sufficient interest switch to 36526?
>>
>> Read further down, we've discussed (unfortunately briefly) Davis's patch
>> closer to the end: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36526#53
>>
>> I don't object to applying it, but like I said, it needs someone to
>> champion it, do a proper review. I don't have the time or interest at the
>> moment.
> 
> I have been using Davis's patch for a long time
> and collected a long list of its problems below.
> Later I could try to help fixing all these issues:

Thank you for testing and cataloguing the problems. So it needs more 
work. I'll Cc Davis, perhaps he would like to continue the effort 
himself, too. Or to at least be aware of the progress.

> 1. diff-goto-line doesn't work with 'C-x v D'
> 
> 2. 'C-c C-d' (log-edit-show-diff) leaves point at end, should leave at beginning
> 
> 3. It should be customizable
> 
> 4. This feature is unusable with 'C-c C-d' (log-edit-show-diff):
> 
> 5. Often when committing a change 'C-c C-d' (log-edit-show-diff)
>     displays only the end of the diff buffer, so some parts of the diff
>     might be committed unnoticed.  This is because 'diff-goto-line'
>     moves point to some random place in the diff output.  It's difficult
>     to understand its logic, why it decides to move to the middle of the
>     multi-file diff.
>     Sometimes displaying the end of the diff buffer makes an impression
>     that it's a complete diff buffer, thus a danger to miss the
>     beginning of the partially hidden diff buffer.
> 
> 6. 'C-c C-d' (log-edit-show-diff)
>     read-file-name("Use file /dev/null: " "/dev/" "/dev/null" t "null")
>     diff-find-file-name()
>     diff-goto-line("Makefile" 33 0)
> 
> 7. on the last hunk it signals the error: "user-error: No next hunk"
> 
> 8. compilation warnings:
>     vc/diff-mode.el:706:1: Warning: Unused lexical variable `i'
>     vc/diff-mode.el:733:30: Warning: reference to free variable
> 
> 9. signals an error:
> 
> Debugger entered--Lisp error: (wrong-type-argument stringp nil)
>    string-to-number(nil)
>    (let ((start (string-to-number (match-string 3))) (len (string-to-number (match-string 4))))
>    (cond ((eobp) nil) ((looking-at diff-hunk-header-re-unified
>    (progn (condition-case nil (diff-hunk-next)
>    (while (progn (condition-case nil (diff-hunk-next)
>    (if (eobp) (goto-char (point-min)) (forward-line -1) (while
>    diff-goto-line("manifest.js" 1 0)
>    apply(diff-goto-line ("manifest.js" 1 0))
>    vc-diff-finish
> 





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51215; Package emacs. Full text available.

Message received at 51215 <at> debbugs.gnu.org:


Received: (at 51215) by debbugs.gnu.org; 19 Oct 2021 07:13:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 19 03:13:28 2021
Received: from localhost ([127.0.0.1]:49235 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mcjJQ-0000Uy-L3
	for submit <at> debbugs.gnu.org; Tue, 19 Oct 2021 03:13:28 -0400
Received: from relay5-d.mail.gandi.net ([217.70.183.197]:53651)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1mcjJN-0000Ug-IJ
 for 51215 <at> debbugs.gnu.org; Tue, 19 Oct 2021 03:13:28 -0400
Received: (Authenticated sender: juri@HIDDEN)
 by relay5-d.mail.gandi.net (Postfix) with ESMTPSA id 08F771C000C;
 Tue, 19 Oct 2021 07:13:17 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#51215: Add a navigation feature to vc and diff mode:
 diff-goto-line
Organization: LINKOV.NET
References: <87k0ifpcc2.fsf@HIDDEN>
 <9618968c-f3f4-da4f-4dba-e34a88036ced@HIDDEN>
 <87k0iag5vr.fsf@HIDDEN> <87ee8ig5ib.fsf@HIDDEN>
 <d2140f38-05cd-fc40-c009-4430086df235@HIDDEN>
Date: Tue, 19 Oct 2021 09:53:44 +0300
In-Reply-To: <d2140f38-05cd-fc40-c009-4430086df235@HIDDEN> (Dmitry Gutov's
 message of "Tue, 19 Oct 2021 03:49:13 +0300")
Message-ID: <87lf2ple0n.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51215
Cc: 51215 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36526
>> Is a different patch than the one I committed. Mine (=Davis) does not
>> touch the vc-root-diff command it is on a strict one-file base and
>> therefore simpler.
>> Why not apply mine and if there is sufficient interest switch to 36526?
>
> Read further down, we've discussed (unfortunately briefly) Davis's patch
> closer to the end: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36526#53
>
> I don't object to applying it, but like I said, it needs someone to
> champion it, do a proper review. I don't have the time or interest at the
> moment.

I have been using Davis's patch for a long time
and collected a long list of its problems below.
Later I could try to help fixing all these issues:

1. diff-goto-line doesn't work with 'C-x v D'

2. 'C-c C-d' (log-edit-show-diff) leaves point at end, should leave at beginning

3. It should be customizable

4. This feature is unusable with 'C-c C-d' (log-edit-show-diff):

5. Often when committing a change 'C-c C-d' (log-edit-show-diff)
   displays only the end of the diff buffer, so some parts of the diff
   might be committed unnoticed.  This is because 'diff-goto-line'
   moves point to some random place in the diff output.  It's difficult
   to understand its logic, why it decides to move to the middle of the
   multi-file diff.
   Sometimes displaying the end of the diff buffer makes an impression
   that it's a complete diff buffer, thus a danger to miss the
   beginning of the partially hidden diff buffer.

6. 'C-c C-d' (log-edit-show-diff)
   read-file-name("Use file /dev/null: " "/dev/" "/dev/null" t "null")
   diff-find-file-name()
   diff-goto-line("Makefile" 33 0)

7. on the last hunk it signals the error: "user-error: No next hunk"

8. compilation warnings:
   vc/diff-mode.el:706:1: Warning: Unused lexical variable `i'
   vc/diff-mode.el:733:30: Warning: reference to free variable

9. signals an error:

Debugger entered--Lisp error: (wrong-type-argument stringp nil)
  string-to-number(nil)
  (let ((start (string-to-number (match-string 3))) (len (string-to-number (match-string 4))))
  (cond ((eobp) nil) ((looking-at diff-hunk-header-re-unified
  (progn (condition-case nil (diff-hunk-next)
  (while (progn (condition-case nil (diff-hunk-next)
  (if (eobp) (goto-char (point-min)) (forward-line -1) (while
  diff-goto-line("manifest.js" 1 0)
  apply(diff-goto-line ("manifest.js" 1 0))
  vc-diff-finish




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51215; Package emacs. Full text available.

Message received at 51215 <at> debbugs.gnu.org:


Received: (at 51215) by debbugs.gnu.org; 19 Oct 2021 00:54:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 18 20:54:51 2021
Received: from localhost ([127.0.0.1]:48899 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mcdP1-0007gF-1W
	for submit <at> debbugs.gnu.org; Mon, 18 Oct 2021 20:54:51 -0400
Received: from mail-lj1-f173.google.com ([209.85.208.173]:37549)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1mcdOz-0007g1-9G
 for 51215 <at> debbugs.gnu.org; Mon, 18 Oct 2021 20:54:49 -0400
Received: by mail-lj1-f173.google.com with SMTP id g8so2944008ljn.4
 for <51215 <at> debbugs.gnu.org>; Mon, 18 Oct 2021 17:54:49 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=sender:subject:to:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=WNmkuYgwvpMV45T6sTJ2B6/ZJL/rVTMmH/4Yb+q6oCM=;
 b=lB/EfxlQEl6eMgiK6WBYavA0FP7Tki3BZbRZoEECDrGVn53ywc6g8BrN5CuoIkDw/N
 k6PZ4YFIGNRM5xIuBLGGJ5cj8bWLMwku0VROlWTFKncoM2ueOeqAnT7JPUdvwYBTv8Ee
 kBsJD2meLZtXiPZ2aiOes0SInt88g6V5vgW3LTtaaIvrZI9mJtEKjc0smU9rGvTQg/Zn
 QizfmKwJvwq8N7g2iGRcvWmw+WhdcoFxVvQFye/aOLkp/VBdIcjGhE46hLtqlbLj60uU
 jtyq9GEHDYitWHUkatVQqhvHiYQc95lrYvlUFwtKmKQyI8c0eRvh0hQyEirGM03PBGP9
 BK6Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:sender:subject:to:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=WNmkuYgwvpMV45T6sTJ2B6/ZJL/rVTMmH/4Yb+q6oCM=;
 b=30M0Vy9qYBHkrfDIHKs1Riu8FK64gLttZfZSE629X0DJ5qbzaqaPZKy990Q4vEmYYH
 cquYVAn+pvWHwuydPvdh2v//2kAJSPY9s5o/qNet71twcWAqiZfhGdBp2zY2A8RZwah0
 1S8yQDagmC/fX7nVilLkD2AcnVUxl7l5Y9rSfvxJ24qKL5+JHhe3xDPc05G5RRMmSrtn
 Vokvr/gMwu/KBVZR1asF8hGKZDsxtBOYAZIaTL6+oh+7Dn1jxLRU/vxbvVR6ejI9+vct
 PySJzCFpi6dvEUfA1EpuyC+k+yEgupzC5Oy94vWIJ+aP0gGpTt7ZW+61+kCeY554og5d
 DPrw==
X-Gm-Message-State: AOAM5300UoX744/ybm1bCbsw4S+vGPgMR/ScBdn/WRe4vGaZ6HsCPo4x
 /WVy2YDRPcgjkUtFDkWFpekhpJ/Pb0M=
X-Google-Smtp-Source: ABdhPJxrQY59u8JeRygHL8LDH8qzsRbwTbbC6Tky7uB0DlB68VP7H/pjPh2lqtsSyeqjxy6BzfrqlQ==
X-Received: by 2002:a2e:b4ba:: with SMTP id q26mr3426081ljm.39.1634604883141; 
 Mon, 18 Oct 2021 17:54:43 -0700 (PDT)
Received: from [192.168.0.103] ([5.18.248.29])
 by smtp.googlemail.com with ESMTPSA id d17sm1445475lfg.122.2021.10.18.17.54.42
 for <51215 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Mon, 18 Oct 2021 17:54:42 -0700 (PDT)
Subject: Re: bug#51215: Add a navigation feature to vc and diff mode:
 diff-goto-line
To: 51215 <at> debbugs.gnu.org
References: <87k0ifpcc2.fsf@HIDDEN>
 <9618968c-f3f4-da4f-4dba-e34a88036ced@HIDDEN> <87k0iag5vr.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <7dc92f6f-0e66-398a-cf2c-941d16026b66@HIDDEN>
Date: Tue, 19 Oct 2021 03:54:42 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.13.0
MIME-Version: 1.0
In-Reply-To: <87k0iag5vr.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.4 (/)
X-Debbugs-Envelope-To: 51215
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.6 (/)

Hi Uwe,

On 18.10.2021 10:16, Uwe Brauer wrote:

 >> The most recent discussion regarding it can be found in bug#36526.
 >
 > I am not that used to that interface I jumped to
 > 
https://lists.gnu.org/archive/html/emacs-bug-tracker/2020-08/msg00633.html

You can read the discussion starting from 
https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36526#53.

 >> To sum up: the patch(es) have merit, and they're waiting for someone
 >> to champion their inclusion: test them for bugs, compare the different
 >> available implementations of the "skip to" functionality, and
 >> generally examine how the new functionality affects the existing
 >> workflows (e.g. whether it should be enabled on root diffs).
 >
 > Forgive me my ignorance (maybe because I am  a mercurial user 😇)
 > the documentation vc-root-diff talks about tree revision
 >
 > So if I understand that correctly this is for the case I want really
 > consider the diff of the repository?
 >
 > That is the same effect as if:  I change 3 files in the repository 
and would run
 > git diff
 > or
 > hg diff
 > from the command line?

vc-root-diff, yes. 'C-x v D'.

 > If that is the case I would say, disable the feature for that sort of
 > diffs  for the moment. The patch is more useful for
 > one-file-basis.
 > At least that is how  I used it for a year.

OK, thanks for the feedback. But we should consider both changes in the 
proposal, ideally. Not just the one you happened to have been using for 
a period of time.

Would somebody else like to chime in?

 > So what is the best strategy? How can I test the patch concerning
 > bug#36526?
 >
 > The message talks about emacs 26, I am running a 2 month old
 > git master emacs (still 28).
 > So can that patch be tested in version I use?
That's a part of championing the change: try to see whether the patch 
still applies. If not, maybe try updating it yourself.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51215; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 19 Oct 2021 00:49:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 18 20:49:21 2021
Received: from localhost ([127.0.0.1]:48894 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mcdJh-0007Ym-DU
	for submit <at> debbugs.gnu.org; Mon, 18 Oct 2021 20:49:21 -0400
Received: from lists.gnu.org ([209.51.188.17]:38224)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1mcdJf-0007Yd-6c
 for submit <at> debbugs.gnu.org; Mon, 18 Oct 2021 20:49:20 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:50256)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <raaahh@HIDDEN>) id 1mcdJe-0002rh-VJ
 for bug-gnu-emacs@HIDDEN; Mon, 18 Oct 2021 20:49:18 -0400
Received: from mail-lf1-x132.google.com ([2a00:1450:4864:20::132]:43941)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <raaahh@HIDDEN>) id 1mcdJd-0001cB-65
 for bug-gnu-emacs@HIDDEN; Mon, 18 Oct 2021 20:49:18 -0400
Received: by mail-lf1-x132.google.com with SMTP id r19so3524966lfe.10
 for <bug-gnu-emacs@HIDDEN>; Mon, 18 Oct 2021 17:49:16 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=sender:subject:to:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=j5a7gQ1N/nZzh6tS6nARxcXHd3/uNueQe3+iftVmdNs=;
 b=RvOKy4Rr4ZwjyLw59/h7wgccxwGafa3xXgcuPEMGT5WAs0Wwdq4zsL5qxM80XxEILB
 9v6ZPm2jcIqoAUJnwzjK9DbBiDgNA130JvA+LBSF3evzcVffaSEYaDSs5XbqCUOIJQlA
 ZLrSIX71sUxTrDXvjga/i28us++VV53EJlQ8x2hS0D+aq70FO+Oc6s1TCQYu/q1q/ntr
 QH1hmphyRL8ZPq/U9qvoL6zba2+E8JtSx2fMFIOSV0J/X5J4WOm5Xox4snru/J20w0cP
 NFAMMA2ifYCniWwLCnY3sIDVEPF7BqdTHGkM6lQbbf3gv2ORQJNVPEPprmhQznySBmvg
 7NBQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:sender:subject:to:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=j5a7gQ1N/nZzh6tS6nARxcXHd3/uNueQe3+iftVmdNs=;
 b=rebBeGfmEzgNS7Xzu3LOQLRaCiFcORhOrJKeKQhbgKSRNi4I8MhKT2R3OiQ6MKYtru
 AL9JdPaVoK4MWimtzAJ1RxwJ5PC/nmWFSF2y5V9vMbx7nSQzqI4V6/YIuzQKtQY2LZeb
 ajJ9YnrTnXgDEo3o0elqAycJrLvYLiC7S5K9wLHQhqXRkkxlbsdDFdhi3QbgW/D59F2Z
 TFo4qev0fnVZC8fTWqRjxmDAiQ1Xr7ceJQjV0HENZgsoI3yjrv53371Uf++ZdmeB5VUW
 ffpvx/GLiPQLOaix0wRYsRAHvp55+hhBI7si0q8Fz1R6kb2eldRLx86YnnIkMktvYOlj
 OMBA==
X-Gm-Message-State: AOAM532hS218p2Usi2BFLolbaF4/UMDcTOt3oHHMYReiRjhAFnD6+fFq
 GsuWN71EDiOHBWetCcEzgX2KV7af2/8=
X-Google-Smtp-Source: ABdhPJxZZIFvvO9WEKFVAwoI791NJjIO8EYT4N4ABLxiXbUY49TYNWVVRaVykOBSh8BYu/TDgAvytQ==
X-Received: by 2002:a05:6512:13a5:: with SMTP id
 p37mr2992973lfa.403.1634604554740; 
 Mon, 18 Oct 2021 17:49:14 -0700 (PDT)
Received: from [192.168.0.103] ([5.18.248.29])
 by smtp.googlemail.com with ESMTPSA id n12sm1789257ljh.55.2021.10.18.17.49.13
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Mon, 18 Oct 2021 17:49:14 -0700 (PDT)
Subject: Re: bug#51215: Add a navigation feature to vc and diff mode:
 diff-goto-line
To: bug-gnu-emacs@HIDDEN
References: <87k0ifpcc2.fsf@HIDDEN>
 <9618968c-f3f4-da4f-4dba-e34a88036ced@HIDDEN> <87k0iag5vr.fsf@HIDDEN>
 <87ee8ig5ib.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <d2140f38-05cd-fc40-c009-4430086df235@HIDDEN>
Date: Tue, 19 Oct 2021 03:49:13 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.13.0
MIME-Version: 1.0
In-Reply-To: <87ee8ig5ib.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 8bit
Received-SPF: pass client-ip=2a00:1450:4864:20::132;
 envelope-from=raaahh@HIDDEN; helo=mail-lf1-x132.google.com
X-Spam_score_int: -14
X-Spam_score: -1.5
X-Spam_bar: -
X-Spam_report: (-1.5 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FORGED_FROMDOMAIN=0.25,
 FREEMAIL_FROM=0.001, HEADER_FROM_DIFFERENT_DOMAINS=0.249, NICE_REPLY_A=-0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -0.9 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.9 (-)

On 18.10.2021 10:24, Uwe Brauer wrote:
>> Hi Dmitry
> 
>> Thanks for answering and clarify some points
> 
>> I am not that used to that interface I jumped to
>> https://lists.gnu.org/archive/html/emacs-bug-tracker/2020-08/msg00633.html
> To answer my own question:
> 
> https://debbugs.gnu.org/cgi/bugreport.cgi?bug=%2336526
> 
> Is a different patch than the one I committed. Mine (=Davis) does not
> touch the vc-root-diff command it is on a strict one-file base and
> therefore simpler.
> 
> Why not apply «mine» and if there is sufficient interest switch to
> 2336526?

Read further down, we've discussed (unfortunately briefly) Davis's patch 
closer to the end: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36526#53

I don't object to applying it, but like I said, it needs someone to 
champion it, do a proper review. I don't have the time or interest at 
the moment.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51215; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 18 Oct 2021 07:24:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 18 03:24:27 2021
Received: from localhost ([127.0.0.1]:45771 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mcN0U-0005K1-TL
	for submit <at> debbugs.gnu.org; Mon, 18 Oct 2021 03:24:27 -0400
Received: from lists.gnu.org ([209.51.188.17]:53030)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mcN0S-0005Jt-Hg
 for submit <at> debbugs.gnu.org; Mon, 18 Oct 2021 03:24:24 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:46136)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mcN0S-0003m4-B7
 for bug-gnu-emacs@HIDDEN; Mon, 18 Oct 2021 03:24:24 -0400
Received: from ciao.gmane.io ([116.202.254.214]:43012)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mcN0Q-0002HF-Qs
 for bug-gnu-emacs@HIDDEN; Mon, 18 Oct 2021 03:24:24 -0400
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mcN0N-0000XH-Vp
 for bug-gnu-emacs@HIDDEN; Mon, 18 Oct 2021 09:24:19 +0200
X-Injected-Via-Gmane: http://gmane.org/
Mail-Followup-To: bug-gnu-emacs@HIDDEN
To: bug-gnu-emacs@HIDDEN
From: Uwe Brauer <oub@HIDDEN>
Subject: Re: bug#51215: Add a navigation feature to vc and diff mode:
 diff-goto-line
Date: Mon, 18 Oct 2021 09:24:12 +0200
Message-ID: <87ee8ig5ib.fsf@HIDDEN>
References: <87k0ifpcc2.fsf@HIDDEN>
 <9618968c-f3f4-da4f-4dba-e34a88036ced@HIDDEN>
 <87k0iag5vr.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=sha256;   protocol="application/pkcs7-signature"
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Cancel-Lock: sha1:IAcJro4pSNJrmyoHQipn0B4ctIU=
Mail-Copies-To: never
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: -16
X-Spam_score: -1.7
X-Spam_bar: -
X-Spam_report: (-1.7 / 5.0 requ) BAYES_00=-1.9,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


> Hi Dmitry


> Thanks for answering and clarify some points


> I am not that used to that interface I jumped to=20
> https://lists.gnu.org/archive/html/emacs-bug-tracker/2020-08/msg00633.html

To answer my own question:

https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D%2336526

Is a different patch than the one I committed. Mine (=3DDavis) does not
touch the vc-root-diff command it is on a strict one-file base and
therefore simpler.

Why not apply =C2=ABmine=C2=BB and if there is sufficient interest switch to
2336526?=20

--=-=-=
Content-Type: application/pkcs7-signature; name=smime.p7s
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename=smime.p7s
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--=-=-=--





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51215; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 18 Oct 2021 07:16:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 18 03:16:30 2021
Received: from localhost ([127.0.0.1]:45750 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mcMso-00056F-EZ
	for submit <at> debbugs.gnu.org; Mon, 18 Oct 2021 03:16:30 -0400
Received: from lists.gnu.org ([209.51.188.17]:48136)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mcMsm-000567-1d
 for submit <at> debbugs.gnu.org; Mon, 18 Oct 2021 03:16:29 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:44888)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mcMsl-0008N6-RY
 for bug-gnu-emacs@HIDDEN; Mon, 18 Oct 2021 03:16:27 -0400
Received: from ciao.gmane.io ([116.202.254.214]:43724)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mcMsj-000436-LY
 for bug-gnu-emacs@HIDDEN; Mon, 18 Oct 2021 03:16:27 -0400
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1mcMsf-0000qg-3D
 for bug-gnu-emacs@HIDDEN; Mon, 18 Oct 2021 09:16:21 +0200
X-Injected-Via-Gmane: http://gmane.org/
Mail-Followup-To: bug-gnu-emacs@HIDDEN
To: bug-gnu-emacs@HIDDEN
From: Uwe Brauer <oub@HIDDEN>
Subject: Re: bug#51215: Add a navigation feature to vc and diff mode:
 diff-goto-line
Date: Mon, 18 Oct 2021 09:16:08 +0200
Message-ID: <87k0iag5vr.fsf@HIDDEN>
References: <87k0ifpcc2.fsf@HIDDEN>
 <9618968c-f3f4-da4f-4dba-e34a88036ced@HIDDEN>
Mime-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=sha256;   protocol="application/pkcs7-signature"
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Cancel-Lock: sha1:04XL0+Tx3ucg3JaFaIYysG1/kZk=
Mail-Copies-To: never
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: -16
X-Spam_score: -1.7
X-Spam_bar: -
X-Spam_report: (-1.7 / 5.0 requ) BAYES_00=-1.9,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

>>> "DG" =3D=3D Dmitry Gutov <dgutov@HIDDEN> writes:
Hi Dmitry


Thanks for answering and clarify some points
> Hi Uwe,
> On 14.10.2021 23:42, Uwe Brauer wrote:
>> I became very interested in that feature and was not able to install
>> Davis's second patch (most likely to many changes in the last 5 years)
>> His first patch, however, I could still apply and I tested it (using
>> mercurial) almost for a year and it worked flawlessly for me.
>> That is why I strongly recommend to apply the patch, then
>> 1. Either errors are found and these will be corrected or the
>> patch removed
>> 2. Or even better the feature will enhanced
>> But I think to reject the patch, again, would not be a bit of a
>> shame.

> The most recent discussion regarding it can be found in bug#36526.

I am not that used to that interface I jumped to=20
https://lists.gnu.org/archive/html/emacs-bug-tracker/2020-08/msg00633.html

But that seems to be an automatic generated message. How can I see its
history and see that it is really Davis' original patch? The first or
the second. As I said I only tested the first one, for a year now.

> To sum up: the patch(es) have merit, and they're waiting for someone
> to champion their inclusion: test them for bugs, compare the different
> available implementations of the "skip to" functionality, and
> generally examine how the new functionality affects the existing
> workflows (e.g. whether it should be enabled on root diffs).

Forgive me my ignorance (maybe because I am  a mercurial user =F0=9F=98=87)
the documentation vc-root-diff talks about tree revision

So if I understand that correctly this is for the case I want really
consider the diff of the repository?=20

That is the same effect as if:  I change 3 files in the repository and woul=
d run=20
git diff
or=20
hg diff=20
from the command line?

If that is the case I would say, disable the feature for that sort of
diffs  for the moment. The patch is more useful for
one-file-basis.
At least that is how  I used it for a year.

So what is the best strategy? How can I test the patch concerning=20
bug#36526?

The message talks about emacs 26, I am running a 2 month old
git master emacs (still 28).
So can that patch be tested in version I use?

Regards

Uwe=20



--=-=-=
Content-Type: application/pkcs7-signature; name=smime.p7s
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename=smime.p7s
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--=-=-=--





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51215; Package emacs. Full text available.

Message received at 51215 <at> debbugs.gnu.org:


Received: (at 51215) by debbugs.gnu.org; 18 Oct 2021 01:56:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 17 21:56:41 2021
Received: from localhost ([127.0.0.1]:45499 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mcHtJ-0005V1-2I
	for submit <at> debbugs.gnu.org; Sun, 17 Oct 2021 21:56:41 -0400
Received: from mail-lf1-f41.google.com ([209.85.167.41]:42619)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1mcHtG-0005Uj-F2
 for 51215 <at> debbugs.gnu.org; Sun, 17 Oct 2021 21:56:40 -0400
Received: by mail-lf1-f41.google.com with SMTP id x27so63598653lfa.9
 for <51215 <at> debbugs.gnu.org>; Sun, 17 Oct 2021 18:56:38 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=yo1EtRHw/I5INnz9E6v3vemFhCQyfXNUJlRkgMAXcyg=;
 b=WzwF0pr425vL7wogtNXpUmNBceC3PBS13wz9phTI/KRe1Osi/Lw5Q1HxhHWWlxd658
 buuqMyL7EirSQwUyr7qNS1djfRT+Z+/UcXbb3HyjCDS6L32VoybxQw/wrBh/EFoPvCd9
 GrcvGVFwfYZMAjETyuFj4m8c2uITxcv6Dg8tB7Wn1v+LwMDyzYOruemrDPZX0B+v5bfg
 5iQU6pvA2CFefS8lNtA574FgeTJkdzdb+I5DRYOB6MJWL3l65u9tsumD5iCqg3PNIzKk
 2yaTBkFo1NJHU7Ntzj/7QpYYQRa12bg7GNicQFqk5XX7OsHBlbeeWxp0lOFYLJeTRvDz
 h63w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=yo1EtRHw/I5INnz9E6v3vemFhCQyfXNUJlRkgMAXcyg=;
 b=W3rn2rDdDNUE0rIYFWeM6qgFMN8O26QbHUDtHPj10q3fY9j5eg2bDBOSdrW32Xa1AX
 kNZW4sVrDGKWP5VQFEhZf+Oem3tUcuwiXlqXlkqaj/vGMz4IikIKvF+NHE07pNYuS9f5
 24ge9tweNOy5e5NJ9HtM2fJWOiGfzdbp/U7YRGXSqSlGAWUKtJtG2+pjbwZgZxIP+1ur
 8c6ZYJk5NNtjVoeWr0VbjveP9jFLKQY0hVd2CyjwqpyBdK3S9yodnXE82J9hlYuRX/ZV
 33PgYBgdMRkRzDHPJIidKilmZK6WpRytw7OVWJ6HtBmaTETwizE15P7CTRw8N3K+hABW
 uL5g==
X-Gm-Message-State: AOAM5300nMPQz6HZpVmz9VLUbhF8tedl2KMDFpgBBlh8iGOEPPIC5oqP
 UmuhbVtHwfBSglmW/PSEi/4=
X-Google-Smtp-Source: ABdhPJySDe9pCgHpaUR+63Xyfx7Ze14P54azXduAHVedFHnw69wP3v908q6ht92BXoZJI0gTVq6hpg==
X-Received: by 2002:a05:6512:108b:: with SMTP id
 j11mr26904308lfg.441.1634522192314; 
 Sun, 17 Oct 2021 18:56:32 -0700 (PDT)
Received: from [192.168.0.103] ([5.18.248.29])
 by smtp.googlemail.com with ESMTPSA id h1sm56699lfu.277.2021.10.17.18.56.31
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Sun, 17 Oct 2021 18:56:32 -0700 (PDT)
Subject: Re: bug#51215: Add a navigation feature to vc and diff mode:
 diff-goto-line
To: Uwe Brauer <oub@HIDDEN>, 51215 <at> debbugs.gnu.org
References: <87k0ifpcc2.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <9618968c-f3f4-da4f-4dba-e34a88036ced@HIDDEN>
Date: Mon, 18 Oct 2021 04:56:31 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.13.0
MIME-Version: 1.0
In-Reply-To: <87k0ifpcc2.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.4 (/)
X-Debbugs-Envelope-To: 51215
Cc: Davis Herring <herring@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.6 (/)

Hi Uwe,

On 14.10.2021 23:42, Uwe Brauer wrote:
> I became very interested in that feature and was not able to install
> Davis's second patch (most likely to many changes in the last 5 years)
> 
> His first patch, however, I could still apply and I tested it (using
> mercurial) almost for a year and it worked flawlessly for me.
> 
> That is why I strongly recommend to apply the patch, then
> 
>      1. Either errors are found and these will be corrected or the patch removed
>      2. Or even better the feature will enhanced
> 
> But I think to reject the patch, again, would not be a bit of a shame.

The most recent discussion regarding it can be found in bug#36526.

To sum up: the patch(es) have merit, and they're waiting for someone to 
champion their inclusion: test them for bugs, compare the different 
available implementations of the "skip to" functionality, and generally 
examine how the new functionality affects the existing workflows (e.g. 
whether it should be enabled on root diffs).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51215; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 14 Oct 2021 20:43:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 14 16:43:19 2021
Received: from localhost ([127.0.0.1]:37201 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mb7ZL-0003JE-Mz
	for submit <at> debbugs.gnu.org; Thu, 14 Oct 2021 16:43:19 -0400
Received: from lists.gnu.org ([209.51.188.17]:45878)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <oub@HIDDEN>) id 1mb7ZH-0003J4-VJ
 for submit <at> debbugs.gnu.org; Thu, 14 Oct 2021 16:43:14 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:34232)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <oub@HIDDEN>) id 1mb7ZG-0004ss-Sy
 for bug-gnu-emacs@HIDDEN; Thu, 14 Oct 2021 16:43:11 -0400
Received: from mail-wm1-x32c.google.com ([2a00:1450:4864:20::32c]:44937)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <oub@HIDDEN>) id 1mb7ZA-0003OP-3s
 for bug-gnu-emacs@HIDDEN; Thu, 14 Oct 2021 16:43:06 -0400
Received: by mail-wm1-x32c.google.com with SMTP id
 b189-20020a1c1bc6000000b0030da052dd4fso559755wmb.3
 for <bug-gnu-emacs@HIDDEN>; Thu, 14 Oct 2021 13:43:01 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=mat.ucm.es; s=google;
 h=from:to:cc:subject:date:message-id:mime-version;
 bh=2/tWGsKQWECrAYUiSTojJPFr+OK6rpXrTwvxsJPEozs=;
 b=h1F2+sHtHh72f9V2AIwr2RXR4KC2GuLv9oHVJ6WDmVmC94ZTdEV/89jtx1UHrm7yMI
 tGlmA6NNZPYWkX1/XsI1xV/UOi5bTjXBE06a2Ag8NuFGl3nDzavUa2gXzo0+raPucfGS
 LNEXuQdyriu2HfcTnNIq/gckzED9gftYACGms=
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:from:to:cc:subject:date:message-id:mime-version;
 bh=2/tWGsKQWECrAYUiSTojJPFr+OK6rpXrTwvxsJPEozs=;
 b=EOjDvWs+Mm7H9r/QpkuxVex5uZTpZIeEX++yZF9rYKLp4n35Wa8Ms3P6csEPnYU71r
 510T6R4Jxats3uJT4b37RpOpdPGYwgl3+C9gnKpNN0EYIG3HFrcgG8v8vUo7DZY/6KLO
 PHxoc+dsH/OMnKrFi0J0e07770uOTaF8OSIzsn6H47drj9b2KLUpKSFN4csT2cuRQbD4
 y8yqr390stOComV6Sc+ViDT3D8QCzO8RFe74aRauqYVoxlh8xUBxieAAcH1nrLX3OWXp
 Ay6S82yM2vZa6te/GLBc6uzvWVDkOpwn9bShZdkHBg7ya2gUktRWoaTwDoRwvWSX6zFc
 xKxw==
X-Gm-Message-State: AOAM532wOKvnaNcVrIPDhFvUnuIwFvSzeT6GRTglaoz9jS8RH2IT/6hB
 lheRZ2SPUiaCqnM3dEp0hVMYZUoV48XnYUD81CDC967h4bezwLa6y87oiVnXEtQM+thgodsbjfu
 WMeQE7W5Z7grEvkKKww1J3YlwkO43uYlEft6COT6kXf9Y9lIw3U+01TnwqZAu
X-Google-Smtp-Source: ABdhPJx/DWGivy2tZnkvEvtocjTUR14xNO5ObiDpHK38OfNGxq5QYlWLuR6GanJnEkbyWHWdy6P5fg==
X-Received: by 2002:a1c:e901:: with SMTP id q1mr8173369wmc.185.1634244180174; 
 Thu, 14 Oct 2021 13:43:00 -0700 (PDT)
Received: from Utnapischtim
 (p2003000613063f55edb8f3ff44329b1f.dip0.t-ipconnect.de.
 [2003:6:1306:3f55:edb8:f3ff:4432:9b1f])
 by smtp.gmail.com with ESMTPSA id q17sm3083982wrm.6.2021.10.14.13.42.57
 (version=TLS1_2 cipher=ECDHE-ECDSA-AES128-GCM-SHA256 bits=128/128);
 Thu, 14 Oct 2021 13:42:59 -0700 (PDT)
X-Mailer: emacs 28.0.50 (via feedmail 11-beta-1 I)
From: Uwe Brauer <oub@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: Add a navigation feature to vc and diff mode: diff-goto-line
X-Hashcash: 1:20:211014:bug-gnu-emacs@HIDDEN::xVc94u4Af8l2CMON:00000000000000000000000000000000000000003dsE
Date: Thu, 14 Oct 2021 22:42:53 +0200
Message-ID: <87k0ifpcc2.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
Received-SPF: pass client-ip=2a00:1450:4864:20::32c; envelope-from=oub@HIDDEN;
 helo=mail-wm1-x32c.google.com
X-Spam_score_int: -19
X-Spam_score: -2.0
X-Spam_bar: --
X-Spam_report: (-2.0 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, RCVD_IN_DNSWL_NONE=-0.0001,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
Cc: Davis Herring <herring@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

--=-=-=
Content-Type: text/plain

Tags: patch

<#secure method=smime mode=sign>
Hi all


Attached you find a patch, in a git compatible format, (to be installed
with git apply --patch-format=hg) provided by Davis Herring with Davis's
approval of course. Davis has already signed the FSF papers.

I would like to also discuss the whole idea connected to that patch.
Please tell me whether that is appropriate, and if it is not, we might
continue the discussion on the developer list. I will send just in case
a similar message to the developer mailing list. 

A bit of history to put that into context: 5 years ago Davis Herring
send a patch (with respect to vc.el and diff-mode.el) to the devel
list, see the link for further details.

[[https://lists.gnu.org/archive/html/emacs-devel/2016-02/msg01066.html][First short vc-diff patch]]

The idea of that patch can be described best by referring to is the
diff-hg package. The function `diff-hl-diff-goto-hunk' shows the
un-committed changes in a file, and allows to jump to these changes.
Strangely enough vc-diff does not provide a similar  feature. Davis' Harris
patch, however, does introduce it.

I find it especially helpful in collaboration where push and pulling
to/from a repository, using either git or mercurial. I presume most of
the users in this mailing list are acquainted with such a workflow, but
if necessary I could provide more details.

That patch was considered as interesting but certain enhancements were
required. So Davis send a much larger patch 6 month later. That patch
however was rejected as being to large. 
[[https://lists.gnu.org/archive/html/emacs-devel/2016-07/msg00727.html][Second longer patch, cannot be merged]]

I became very interested in that feature and was not able to install
Davis's second patch (most likely to many changes in the last 5 years)

His first patch, however, I could still apply and I tested it (using
mercurial) almost for a year and it worked flawlessly for me. 

That is why I strongly recommend to apply the patch, then 

    1. Either errors are found and these will be corrected or the patch removed
    2. Or even better the feature will enhanced

But I think to reject the patch, again, would not be a bit of a shame.

regards

Uwe Brauer 




In GNU Emacs 28.0.50 (build 1, x86_64-pc-linux-gnu, X toolkit, cairo version 1.14.6, Xaw3d scroll bars)
 of 2021-07-31 built on Utnapischtim
Repository revision: 83a915d3dfafd5f3d737afe1e13b75e4dd3aef96
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.11804000
System Description: Ubuntu 16.04.7 LTS

Configured using:
 'configure --prefix=/opt/emacs28 --with-x-toolkit=athena --without-pop
 --with-mailutils'


--=-=-=
Content-Type: text/patch
Content-Disposition: attachment; filename=diff-goto-line.patch

# HG changeset patch
# User Davis Herring <herring@HIDDEN>
# Date 1634243435 -7200
#      Thu Oct 14 22:30:35 2021 +0200
# Node ID 18f4bbf01c0247e973b636163991fe1590459f1b
# Parent  0745c5efa8df0977a457656484c15ca4d53392c6
Add a navigation feature to vc and diff mode: diff-goto-line

* lisp/vc/vc.el (diff-goto-line): new decalare function to include the
  new diff-goto-line-functionality.

* lisp/vc/vc.el (vc-diff-finish): Modify the funcion, to suppor the
  new diff-goto-line-functionality.

* lisp/vc/diff-mode.el (diff-goto-line): New function that allows to
  jump from a specific line in the source buffer to the corresponding
  line in the buffer.

* lisp/vc/diff-mode.el (diff-hunk-header-re): modify the const, so
  that it can be used with the new diff-goto-line-functionality.

* lisp/vc/diff-mode.el (diff-hunk-header-re-context): modify the
  const, so that it can be used with the new
  diff-goto-line-functionality.

* lisp/vc/diff-mode.el (diff-hunk-header-re): Modify the const, to be
  used with new diff-goto-line-functionality.

* lisp/vc/diff-mode.el: (diff-hunk-header-re-context): New variable
  that allows to jump from a specific line in the source buffer to the
  corresponding line in the diff buffer.

diff --git a/lisp/vc/diff-mode.el b/lisp/vc/diff-mode.el
--- a/lisp/vc/diff-mode.el
+++ b/lisp/vc/diff-mode.el
@@ -442,8 +442,10 @@
 
 (defconst diff-hunk-header-re-unified
   "^@@ -\\([0-9]+\\)\\(?:,\\([0-9]+\\)\\)? \\+\\([0-9]+\\)\\(?:,\\([0-9]+\\)\\)? @@")
+(defconst diff-hunk-header-re-context
+  "\\*\\{15\\}\\(?: .*\\)?\n\\*\\*\\* \\(\\([0-9]+\\)\\(?:,\\(-?[0-9]+\\)\\)?\\) \\*\\*\\*\\*")
 (defconst diff-context-mid-hunk-header-re
-  "--- \\([0-9]+\\)\\(?:,\\([0-9]+\\)\\)? ----$")
+  "^--- \\([0-9]+\\)\\(?:,\\([0-9]+\\)\\)? ----$")
 
 (defvar diff-use-changed-face (and (face-differs-from-default-p 'diff-changed)
 				   (not (face-equal 'diff-changed 'diff-added))
@@ -526,7 +528,9 @@
 See https://lists.gnu.org/r/emacs-devel/2007-11/msg01990.html")
 
 (defconst diff-hunk-header-re
-  (concat "^\\(?:" diff-hunk-header-re-unified ".*\\|\\*\\{15\\}.*\n\\*\\*\\* .+ \\*\\*\\*\\*\\|[0-9]+\\(,[0-9]+\\)?[acd][0-9]+\\(,[0-9]+\\)?\\)$"))
+  (concat "^\\(?:" diff-hunk-header-re-unified ".*\\|"
+          diff-hunk-header-re-context
+          "\\|[0-9]+\\(,[0-9]+\\)?[acd][0-9]+\\(,[0-9]+\\)?\\)$"))
 (defconst diff-file-header-re (concat "^\\(--- .+\n\\+\\+\\+ \\|\\*\\*\\* .+\n--- \\|[^-+!<>0-9@* \n]\\).+\n" (substring diff-hunk-header-re 1)))
 
 (defconst diff-separator-re "^--+ ?$")
@@ -716,6 +720,46 @@
 (easy-mmode-define-navigation
  diff-file diff-file-header-re "file" diff-end-of-file)
 
+(defun diff-goto-line (file line column)
+  "Go to the place in this diff producing LINE and COLUMN in FILE.
+If LINE (in the new version of FILE) is included (in the diff
+buffer as +/! line or a context line), move to it and then COLUMN
+characters forward.  If it is absent, go to the first hunk
+starting after LINE, or to the end if none does.  If FILE isn't
+mentioned, go to the beginning of the buffer."
+  (goto-char (point-min))
+  (while (and (re-search-forward diff-file-header-re nil 'move)
+              (not (string-equal (diff-find-file-name) file))))
+  (if (eobp) (goto-char (point-min))
+    (forward-line -1)
+    (while
+        (progn
+          (condition-case nil (diff-hunk-next)
+            (error (goto-char (point-max))))
+          (cond ((eobp) nil)            ; end of the line
+                ((looking-at diff-hunk-header-re-unified)
+                 (let ((start (string-to-number (match-string 3)))
+                       ;; FIXME: assuming that we have the length
+                       (len (string-to-number (match-string 4))))
+                   (cond ((< line start) nil)    ; nothing found
+                         ((< line (+ start len)) ; this is our stop
+                          (dotimes (i (- line start -1))
+                            (while (progn (forward-line 1)
+                                          (eq (char-after) ?-))))
+                          (forward-char (1+ column)))
+                         (t))))         ; keep looking
+                ((looking-at diff-hunk-header-re-context)
+                 (re-search-forward diff-context-mid-hunk-header-re)
+                 (let ((start (string-to-number (match-string 2)))
+                       ;; FIXME: assuming that we have the length
+                       (end (string-to-number (match-string 3))))
+                   (cond ((< line start) nil) ; nothing found
+                         ((<= line end)       ; this is our stop
+                          (forward-line (- line start -1))
+                          (forward-char (+ column 2)))
+                         (t))))         ; keep looking
+                (t (error "Unified or context diffs only")))))))
+
 (defun diff-bounds-of-hunk ()
   "Return the bounds of the diff hunk at point.
 The return value is a list (BEG END), which are the hunk's start
@@ -1186,7 +1230,11 @@
           (inhibit-read-only t))
       (save-excursion
         (goto-char start)
-        (while (and (re-search-forward "^\\(\\(\\*\\*\\*\\) .+\n\\(---\\) .+\\|\\*\\{15\\}.*\n\\*\\*\\* \\([0-9]+\\),\\(-?[0-9]+\\) \\*\\*\\*\\*\\)\\(?: \\(.*\\)\\|$\\)" nil t)
+        (while (and (re-search-forward
+                     (concat "^\\(\\(\\*\\*\\*\\) .+\n\\(---\\) .+\\|"
+                             diff-hunk-header-re-context
+                             "\\)\\(?: \\(.*\\)\\|$\\)")
+                     nil t)
                     (< (point) end))
           (combine-after-change-calls
             (if (match-beginning 2)
@@ -1196,15 +1244,15 @@
                   (replace-match "+++" t t nil 3)
                   (replace-match "---" t t nil 2))
               ;; we matched a hunk header
-              (let ((line1s (match-string 4))
-                    (line1e (match-string 5))
+              (let ((line1s (match-string 5))
+                    (line1e (match-string 6))
                     (pt1 (match-beginning 0))
                     ;; Variables to use the special undo function.
                     (old-undo buffer-undo-list)
                     (old-end (marker-position end))
                     ;; We currently throw away the comment that can follow
                     ;; the hunk header.  FIXME: Preserve it instead!
-                    (reversible (not (match-end 6))))
+                    (reversible (not (match-end 7))))
                 (replace-match "")
                 (unless (re-search-forward
                          diff-context-mid-hunk-header-re nil t)
@@ -1282,7 +1330,11 @@
 	(inhibit-read-only t))
     (save-excursion
       (goto-char start)
-      (while (and (re-search-forward "^\\(\\([-*][-*][-*] \\)\\(.+\\)\n\\([-+][-+][-+] \\)\\(.+\\)\\|\\*\\{15\\}.*\n\\*\\*\\* \\(.+\\) \\*\\*\\*\\*\\|@@ -\\([0-9,]+\\) \\+\\([0-9,]+\\) @@.*\\)$" nil t)
+      (while (and (re-search-forward
+                   (concat "^\\(\\([-*][-*][-*] \\)\\(.+\\)\n\\([-+][-+][-+] \\)\\(.+\\)\\|"
+                           diff-hunk-header-re-context
+                           "\\|@@ -\\([0-9,]+\\) \\+\\([0-9,]+\\) @@.*\\)$")
+                   nil t)
 		  (< (point) end))
 	(combine-after-change-calls
 	  (cond
@@ -1646,13 +1698,13 @@
 
        ;; A context diff.
        ((eq (char-after) ?*)
-        (if (not (looking-at "\\*\\{15\\}\\(?: .*\\)?\n\\*\\*\\* \\([0-9]+\\)\\(?:,\\([0-9]+\\)\\)? \\*\\*\\*\\*"))
+        (if (not (looking-at diff-hunk-header-re-context))
             (error "Unrecognized context diff first hunk header format")
           (forward-line 2)
           (diff-sanity-check-context-hunk-half
-	   (if (match-end 2)
-	       (1+ (- (string-to-number (match-string 2))
-		      (string-to-number (match-string 1))))
+           (if (match-end 3)
+               (1+ (- (string-to-number (match-string 3))
+                      (string-to-number (match-string 2))))
 	     1))
           (if (not (looking-at diff-context-mid-hunk-header-re))
               (error "Unrecognized context diff second hunk header format")
diff --git a/lisp/vc/vc.el b/lisp/vc/vc.el
--- a/lisp/vc/vc.el
+++ b/lisp/vc/vc.el
@@ -739,6 +739,7 @@
 (require 'cl-lib)
 
 (declare-function diff-setup-whitespace "diff-mode" ())
+(declare-function diff-goto-line "diff-mode")
 
 (eval-when-compile
   (require 'dired))
@@ -1716,7 +1717,7 @@
       ;; any switches in diff-switches.
       (when (listp switches) switches))))
 
-(defun vc-diff-finish (buffer messages)
+(defun vc-diff-finish (buffer messages loc)
   ;; The empty sync output case has already been handled, so the only
   ;; possibility of an empty output is for an async process.
   (when (buffer-live-p buffer)
@@ -1730,7 +1731,8 @@
 	(diff-setup-whitespace)
 	(goto-char (point-min))
 	(when window
-	  (shrink-window-if-larger-than-buffer window)))
+	  (shrink-window-if-larger-than-buffer window))
+        (when loc (apply #'diff-goto-line loc)))
       (when (and messages (not emptyp))
 	(message "%sdone" (car messages))))))
 
@@ -1754,7 +1756,8 @@
 	 ;; but the only way to set it for each file included would
 	 ;; be to call the back end separately for each file.
 	 (coding-system-for-read
-	  (if files (vc-coding-system-for-diff (car files)) 'undecided)))
+	  (if files (vc-coding-system-for-diff (car files)) 'undecided))
+	 loc)
     ;; On MS-Windows and MS-DOS, Diff is likely to produce DOS-style
     ;; EOLs, which will look ugly if (car files) happens to have Unix
     ;; EOLs.
@@ -1791,6 +1794,19 @@
                      (if async 'async 1) "diff" file
                      (append (vc-switches nil 'diff) `(,(null-device)))))))
         (setq files (nreverse filtered))))
+    (unless rev2    ; remember the position in the current buffer
+      (let ((f files))
+        (while f
+          (let ((buf (find-buffer-visiting (car f))))
+            (when buf
+              (setq loc
+                    (with-current-buffer buf
+                      (save-restriction
+                        (widen)
+                        (list (file-relative-name (car f))
+                              (line-number-at-pos)
+                              (- (point) (line-beginning-position)))))))
+            (setq f (unless (eq buf (current-buffer)) (cdr f)))))))
     (vc-call-backend (car vc-fileset) 'diff files rev1 rev2 buffer async)
     (set-buffer buffer)
     (diff-mode)
@@ -1815,7 +1831,7 @@
       ;; after `pop-to-buffer'; the former assumes the diff buffer is
       ;; shown in some window.
       (let ((buf (current-buffer)))
-        (vc-run-delayed (vc-diff-finish buf (when verbose messages))))
+        (vc-run-delayed (vc-diff-finish buf (when verbose messages) loc)))
       ;; In the async case, we return t even if there are no differences
       ;; because we don't know that yet.
       t)))

--=-=-=--




Acknowledgement sent to Uwe Brauer <oub@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#51215; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 19 Oct 2021 23:30:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.